Loading...
Searching...
No Matches
Opm::DenseAd::Evaluation< ValueT, numDerivs, staticSize > Class Template Reference

Represents a function evaluation and its derivatives w.r.t. More...

`#include <Evaluation.hpp>`

## Public Types

typedef ValueT | ValueType
| field type

## Public Member Functions

OPM_HOST_DEVICE constexpr int | size () const
| number of derivatives
OPM_HOST_DEVICE | Evaluation ()
| default constructor
| Evaluation (const Evaluation &other)=default
| copy other function evaluation
template<class RhsValueType>
OPM_HOST_DEVICE constexpr | Evaluation (const RhsValueType &c)
template<class RhsValueType>
OPM_HOST_DEVICE | Evaluation (const RhsValueType &c, int varPos)
OPM_HOST_DEVICE constexpr void | clearDerivatives ()
OPM_HOST_DEVICE void | copyDerivatives (const Evaluation &other)
OPM_HOST_DEVICE Evaluation & | operator+= (const Evaluation &other)
template<class RhsValueType>
OPM_HOST_DEVICE Evaluation & | operator+= (const RhsValueType &other)
OPM_HOST_DEVICE Evaluation & | operator-= (const Evaluation &other)
template<class RhsValueType>
OPM_HOST_DEVICE Evaluation & | operator-= (const RhsValueType &other)
OPM_HOST_DEVICE Evaluation & | operator*= (const Evaluation &other)
template<class RhsValueType>
OPM_HOST_DEVICE Evaluation & | operator*= (const RhsValueType &other)
OPM_HOST_DEVICE Evaluation & | operator/= (const Evaluation &other)
template<class RhsValueType>
OPM_HOST_DEVICE Evaluation & | operator/= (const RhsValueType &other)
OPM_HOST_DEVICE Evaluation | operator+ (const Evaluation &other) const
template<class RhsValueType>
OPM_HOST_DEVICE Evaluation | operator+ (const RhsValueType &other) const
OPM_HOST_DEVICE Evaluation | operator- (const Evaluation &other) const
template<class RhsValueType>
OPM_HOST_DEVICE Evaluation | operator- (const RhsValueType &other) const
OPM_HOST_DEVICE Evaluation | operator- () const
OPM_HOST_DEVICE Evaluation | operator* (const Evaluation &other) const
template<class RhsValueType>
OPM_HOST_DEVICE Evaluation | operator* (const RhsValueType &other) const
OPM_HOST_DEVICE Evaluation | operator/ (const Evaluation &other) const
template<class RhsValueType>
OPM_HOST_DEVICE Evaluation | operator/ (const RhsValueType &other) const
template<class RhsValueType>
OPM_HOST_DEVICE Evaluation & | operator= (const RhsValueType &other)
Evaluation & | operator= (const Evaluation &other)=default
template<class RhsValueType>
OPM_HOST_DEVICE bool | operator== (const RhsValueType &other) const
OPM_HOST_DEVICE bool | operator== (const Evaluation &other) const
OPM_HOST_DEVICE bool | operator!= (const Evaluation &other) const
template<class RhsValueType>
OPM_HOST_DEVICE bool | operator!= (const RhsValueType &other) const
template<class RhsValueType>
OPM_HOST_DEVICE bool | operator> (RhsValueType other) const
OPM_HOST_DEVICE bool | operator> (const Evaluation &other) const
template<class RhsValueType>
OPM_HOST_DEVICE bool | operator< (RhsValueType other) const
OPM_HOST_DEVICE bool | operator< (const Evaluation &other) const
template<class RhsValueType>
OPM_HOST_DEVICE bool | operator>= (RhsValueType other) const
OPM_HOST_DEVICE bool | operator>= (const Evaluation &other) const
template<class RhsValueType>
OPM_HOST_DEVICE bool | operator<= (RhsValueType other) const
OPM_HOST_DEVICE bool | operator<= (const Evaluation &other) const
OPM_HOST_DEVICE const ValueType & | value () const
template<class RhsValueType>
OPM_HOST_DEVICE constexpr void | setValue (const RhsValueType &val)
OPM_HOST_DEVICE const ValueType & | derivative (int varIdx) const
OPM_HOST_DEVICE void | setDerivative (int varIdx, const ValueType &derVal)
template<class Serializer>
OPM_HOST_DEVICE void | serializeOp (Serializer &serializer)

## Static Public Member Functions

static OPM_HOST_DEVICE Evaluation | createBlank (const Evaluation &)
static OPM_HOST_DEVICE Evaluation | createConstantZero (const Evaluation &)
static OPM_HOST_DEVICE Evaluation | createConstantOne (const Evaluation &)
template<class RhsValueType>
static OPM_HOST_DEVICE Evaluation | createVariable (const RhsValueType &value, int varPos)
template<class RhsValueType>
static OPM_HOST_DEVICE Evaluation | createVariable (int nVars, const RhsValueType &value, int varPos)
template<class RhsValueType>
static OPM_HOST_DEVICE Evaluation | createVariable (const Evaluation &, const RhsValueType &value, int varPos)
template<class RhsValueType>
static OPM_HOST_DEVICE Evaluation | createConstant (int nVars, const RhsValueType &value)
template<class RhsValueType>
static OPM_HOST_DEVICE Evaluation | createConstant (const RhsValueType &value)
template<class RhsValueType>
static OPM_HOST_DEVICE Evaluation | createConstant (const Evaluation &, const RhsValueType &value)

## Static Public Attributes

static const int | numVars = numDerivs
| the template argument which specifies the number of derivatives (-1 == "DynamicSize" means runtime determined)

## Protected Member Functions

OPM_HOST_DEVICE constexpr int | length_ () const
| length of internal data vector
OPM_HOST_DEVICE constexpr int | valuepos_ () const
| position index for value
OPM_HOST_DEVICE constexpr int | dstart_ () const
| start index for derivatives
OPM_HOST_DEVICE constexpr int | dend_ () const
| end+1 index for derivatives
OPM_HOST_DEVICE constexpr void | checkDefined_ () const
| instruct valgrind to check that the value and all derivatives of the Evaluation object are well-defined.

## Detailed Description

template<class ValueT, int numDerivs, unsigned staticSize = 0>
class Opm::DenseAd::Evaluation< ValueT, numDerivs, staticSize >

Represents a function evaluation and its derivatives w.r.t.

a fixed set of variables.

The documentation for this class was generated from the following file:

- opm/material/densead/Evaluation.hpp